#!/bin/sh
# This script will work on any distribution that has KDE or Gnome or one of the other mechanisms below.
# Be sure to preserve the "&" at the end of any lines launching any executable to allow the
# the executable to run in the background. Otherwise it will hang the calling app while the app
# waits for the executable to finish.

URL=$1

tryKfmclient()
{
	KFMCLIENT_TMP=`whereis kfmclient`
	KFMRESULT=$?

	if ( test "${KFMRESULT}" -eq "0" )
	then
        	# open the URL with this mechanism
        	KFMCLIENT=`echo ${KFMCLIENT_TMP} | awk '{print $2}'`
        	if ( test -f "${KFMCLIENT}" )
        	then
                	"${KFMCLIENT}" exec $URL &
                	return 0
        	fi
	fi

	return 1
}

tryGnome()
{
	GNOME_OPEN_TMP=`whereis gnome-open`
	GNOME_OPEN_RESULT=$?

	if ( test "${GNOME_OPEN_RESULT}" -eq "0" )
	then
        	# open the URL with this mechanism
        	GNOME_OPEN=`echo ${GNOME_OPEN_TMP} | awk '{print $2}'`
        	if ( test -f "${GNOME_OPEN}" )
        	then
                	"${GNOME_OPEN}" $URL &
                	return 0
        	fi
	fi
	return 1

}

tryFirefox()
{
	FIREFOX=`whereis firefox`
	FIREFOX_RESULT=$?

	if ( test "${FIREFOX_RESULT}" -eq "0" )
	then
        	# open the URL with this mechanism
        	FIREFOX_EXE=`echo ${FIREFOX} | awk '{print $2}'`
        	if ( test -f "${FIREFOX_EXE}" )
        	then
                	"${FIREFOX_EXE}" $URL &
                	return 0
        	fi
	fi
	return 1
}

tryMozilla()
{
	MOZILLA=`whereis mozilla`
	MOZILLA_RESULT=$?

	if ( test "${MOZILLA_RESULT}" -eq "0" )
	then
        	# open the URL with this mechanism
        	MOZILLA_EXE=`echo ${MOZILLA} | awk '{print $2}'`
        	if ( test -f "${MOZILLA_EXE}" )
        	then
                	"${MOZILLA_EXE}" $URL &
                	return 0
        	fi
	fi
	return 1
}

if [ "$DESKTOP_SESSION" == "kde" ]
then
	tryKfmclient
	result=$?
	if [ "$result" == "0" ]
	then
		exit 0
	fi

        tryFirefox
	result=$?
        if [ "$result" == "0" ]
        then
                exit 0
        fi

        tryMozilla
	result=$?
        if [ "$result" == "0" ]
        then
                exit 0
        fi

	# we could not find a browser, exit with failure
	exit 1

elif [ "$DESKTOP_SESSION" == "gnome" ]
then
        tryGnome
	result=$?
	if [ "$result" == "0" ]
        then
                exit 0
        fi

	tryFirefox
	result=$?
	if [ "$result" == "0" ]
	then
		exit 0
	fi

	tryMozilla
	result=$?
	if [ "$result" == "0" ]
	then
		exit 0
	fi

	# we could not find a browser, exit with failure
	exit 1

else
	tryFirefox
	result=$?
	if [ "$result" == "0" ]
	then
		exit 0
	fi

	tryKfmclient
	result=$?
	if [ "$result" == "0" ]
	then
		exit 0
	fi

	tryGnome
	result=$?
	if [ "$result" == "0" ]
	then
		exit 0
	fi

	tryMozilla
	result=$?
	if [ "$result" == "0" ]
	then
		exit 0
	fi
	# we could not find a browser, exit with failure
	exit 1
fi

# we could not find a browser, exit with failure. execution should never reach here
exit 1
